// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ngSanitize', 'ionic.ion.autoListDivider', 'countTo', 'balanced', 'dokterSehat.directive.global', 'dokterSehat.service.global', 'dokterSehat.controllers.menu', 'dokterSehat.controllers.home','dokterSehat.controllers.informasiKesehatan', 'dokterSehat.controllers.tipsP3K', 'dokterSehat.controllers.calculator', 'dokterSehat.service.calculator', 'dokterSehat.controllers.direktoriRS', 'dokterSehat.controllers.direktoriDoc', 'dokterSehat.controllers.aboutUs', 'dokterSehat.controllers.search'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "view/menu/menu.html",
    controller: 'menuController'
  })

  .state('app.home', {
    url: "/home",
    views: {
      'menuContent': {
        templateUrl: "view/home/home.html",
        controller: 'homeController'
      }
    }
  })

  .state('app.articleCategory', {
    url: "/articleCategory",
    views: {
      'menuContent': {
        templateUrl: "view/informasi_kesehatan/articleCategory.html",
        controller: 'articleCategoryController'
      }
    }
  })

  .state('app.articleList', {
    url: "/articleCategory/:categoryId",
    views: {
      'menuContent': {
        templateUrl: "view/informasi_kesehatan/articleList.html",
        controller: 'articleListController'
      }
    }
  })

  .state('app.article', {
    url: "/articleCategory/:categoryId/:articleId",
    views: {
      'menuContent': {
        templateUrl: "view/informasi_kesehatan/article.html",
        controller: 'articleController'
      }
    }
  })

  .state('app.tipsP3KList', {
    url: "/tipsP3K",
    views: {
      'menuContent': {
        templateUrl: "view/tips_p3k/listings.html",
        controller: 'tipsP3KController'
      }
    }
  })

  .state('app.tipsP3KDetails', {
    url: "/tipsP3K/:id",
    views: {
      'menuContent': {
        templateUrl: "view/tips_p3k/details.html",
        controller: 'tipsP3KDetailsController'
      }
    }
  })

  .state('app.calculatorList', {
    url: "/calculator",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/listings.html",
        controller: 'calculatorListingController'
      }
    }
  })

  .state('app.calculatorBMI', {
    url: "/calculatorBMI",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/kalkulator_bmi.html",
        controller: 'calculatorBMIController'
      }
    }
  })

  .state('app.calculatorBMIResults', {
    url: "/calculatorBMIResults",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/results_bmi.html",
        controller: 'calculatorBMIResultsController'
      }
    }
  })

  .state('app.calculatorKalori', {
    url: "/calculatorKalori",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/kalkulator_kalori.html",
        controller: 'calculatorKaloriController'
      }
    }
  })

  .state('app.calculatorKaloriResults', {
    url: "/calculatorKaloriResults",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/results_kalori.html",
        controller: 'calculatorKaloriResultsController'
      }
    }
  })

  .state('app.calculatorKesuburan', {
    url: "/calculatorKesuburan",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/kalkulator_kesuburan.html",
        controller: 'calculatorKesuburanController'
      }
    }
  })

  .state('app.calculatorKesuburanResults', {
    url: "/calculatorKesuburanResults",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/results_kesuburan.html",
        controller: 'calculatorKesuburanResultsController'
      }
    }
  })

  .state('app.calculatorUsiaHamil', {
    url: "/calculatorUsiaHamil",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/kalkulator_usia_hamil.html",
        controller: 'calculatorUsiaHamilController'
      }
    }
  })

  .state('app.calculatorUsiaHamilResults', {
    url: "/calculatorUsiaHamilResults",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/results_usia_hamil.html",
        controller: 'calculatorUsiaHamilResultsController'
      }
    }
  })

  .state('app.calculatorPrediksi', {
    url: "/calculatorPrediksi",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/kalkulator_prediksi.html",
        controller: 'calculatorPrediksiController'
      }
    }
  })

  .state('app.calculatorPrediksiResults', {
    url: "/calculatorPrediksiResults",
    views: {
      'menuContent': {
        templateUrl: "view/kalkulator/results_prediksi.html",
        controller: 'calculatorPrediksiResultsController'
      }
    }
  })

  .state('app.direktoriRSListAll', {
    url: "/direktoriRSAll",
    views: {
      'menuContent': {
        templateUrl: "view/direktori_rs/listings_all.html",
        controller: 'hospDirectoryController'
      }
    }
  })

  .state('app.direktoriRSDetails', {
    url: "/direktoriRSAll/:id",
    views: {
      'menuContent': {
        templateUrl: "view/direktori_rs/details.html",
        controller: 'hospDirectoryDetailsController'
      }
    }
  })

  .state('app.direktoriDocList', {
    url: "/direktoriDocList",
    views: {
      'menuContent': {
        templateUrl: "view/direktori_dr/listings.html",
        controller: 'docDirectoryController'
      }
    }
  })

  .state('app.direktoriDocDetails', {
    url: "/direktoriDocList/:id",
    views: {
      'menuContent': {
        templateUrl: "view/direktori_dr/details.html",
        controller: 'docDirectoryDetailsController'
      }
    }
  })

  .state('app.aboutUsList', {
    url: "/aboutUs",
    views: {
      'menuContent': {
        templateUrl: "view/about_us/listings.html",
        controller: 'aboutUsController'
      }
    }
  })

  .state('app.aboutUsDetails', {
    url: "/aboutUs/:id",
    views: {
      'menuContent': {
        templateUrl: "view/about_us/details.html",
        controller: 'aboutUsDetailsController'
      }
    }
  })

  .state('app.search', {
    url: "/search",
    views: {
      'menuContent': {
        templateUrl: "view/search/head.html",
        controller: 'searchController'
      }
    }
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
});
