angular.module('dokterSehat.controllers.direktoriDoc', [])

.controller('docDirectoryController', function($scope, GlobalURL, BalancedHTTP, BalancedAlert) {
  //Google Analytics
  var gaPageTitle = "Doctor Directory Listing Page";
  ga_storage._trackPageview(gaPageTitle);

  $scope.contentLoaded = false;
  $scope.cities = [];
  //set url
  var url = GlobalURL.get() + "/modules/direktori_dr/_ext_get_listings.php";
  //get data
  BalancedHTTP.get(url).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.data = response.data.data;
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });

  $scope.share = function (id, title, name) {
      var subject = '';
      var message = 'DokterSehat.com - ' + title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      var link = 'http://doktersehat.com/' + name;
      console.log(link);

      window.plugins.socialsharing.share(message, subject, null, link);
  }

  $scope.call = function(phoneNumber){
    if(phoneNumber != null){
      window.location.href = 'tel:'+ phoneNumber;
    }else{
      BalancedAlert.alert('Number not found', "Number is not registered in the system.", 'Ok');
    }
  }

})

.controller('docDirectoryDetailsController', function($scope, $stateParams, GlobalURL, BalancedHTTP, BalancedAlert) {
  $scope.contentLoaded = false;
  $scope.cities = [];
  var postId = $stateParams.id;

  //set url
  var url = GlobalURL.get() + "/modules/direktori_dr/_ext_get_details.php";
  //set data
  var data = {post_id: postId}
  //get posts data
  BalancedHTTP.post(url, data).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.data = response.data.data;
          //Google Analytics
          var gaPageTitle = "Doctor Directory - " + response.data.data.title;
          ga_storage._trackPageview(gaPageTitle);
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });

  $scope.share = function (id, title, name) {
      var subject = '';
      var message = 'DokterSehat.com - ' + title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      var link = 'http://doktersehat.com/' + name;
      console.log(link);

      window.plugins.socialsharing.share(message, subject, null, link);
  }

  $scope.call = function(phoneNumber){
    if(phoneNumber != null){
      window.location.href = 'tel:'+ phoneNumber;
    }else{
      BalancedAlert.alert('Number not found', "Number is not registered in the system.", 'Ok');
    }
  }

});
