angular.module('dokterSehat.controllers.direktoriRS', [])

.controller('hospDirectoryController', function($scope, GlobalURL, BalancedHTTP, BalancedAlert, ValidURL) {
  //Google Analytics
  var gaPageTitle = "Hospital Directory Overview Page";
  ga_storage._trackPageview(gaPageTitle);

  $scope.contentLoaded = false;
  $scope.cities = [];
  //set url
  var url = GlobalURL.get() + "/modules/direktori_rs/_ext_get_listings.php";
  //get data
  BalancedHTTP.get(url).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.cities = response.data.data;
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });

  $scope.share = function (id, title, name) {
      var subject = '';
      var message = 'DokterSehat.com - ' + title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      var link = 'http://doktersehat.com/' + name;

      window.plugins.socialsharing.share(message, subject, null, link);
  }

  $scope.visitWebsite = function(url){
    var valid = ValidURL.check(url);
    if(valid){
      window.open(url, '_blank', 'location=yes');
    }else{
      BalancedAlert.alert('No Website', "This hospital does not have website yet.", 'Ok');
    }
  }

  $scope.call = function(phoneNumber){
    window.location.href = 'tel:'+ phoneNumber;
  }

})

.controller('hospDirectoryDetailsController', function($scope, $stateParams, GlobalURL, BalancedHTTP, BalancedAlert, ValidURL) {
  $scope.contentLoaded = false;
  $scope.cities = [];
  var postId = $stateParams.id;
  //set url
  var url = GlobalURL.get() + "/modules/direktori_rs/_ext_get_details.php";
  //set data
  var data = {post_id: postId}
  //get posts data
  BalancedHTTP.post(url, data).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.data = response.data.data;
          //Google Analytics
          var gaPageTitle = "Hospital Directory - " + response.data.data.title;
          ga_storage._trackPageview(gaPageTitle);
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });

  $scope.share = function (id, title, name) {
      var subject = '';
      var message = 'DokterSehat.com - ' + title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      var link = 'http://doktersehat.com/' + name;
      console.log(link);

      window.plugins.socialsharing.share(message, subject, null, link);
  }

  $scope.visitWebsite = function(url){
    var valid = ValidURL.check(url);
    if(valid){
      window.open(url, '_blank', 'location=yes');
    }else{
      BalancedAlert.alert('No Website', "This hospital does not have website yet.", 'Ok');
    }
  }

  $scope.call = function(phoneNumber){
    window.location.href = 'tel:'+ phoneNumber;
  }

});
