angular.module('dokterSehat.controllers.home', [])

.controller('homeController', function($scope, $ionicPlatform, $stateParams, $location, GlobalURL, BalancedHTTP, BalancedAlert) {
  //detect internet connection on app launch
  $ionicPlatform.ready(function() {
    var networkState = navigator.connection.type;
    if(networkState === 'unknown' || networkState === 'none' || networkState === null){
      // alert("Koneksi Internet Tidak Terdeteksi");
      BalancedAlert.alert('Koneksi Internet Tidak Terdeteksi', 'Aplikasi ini memerlukan koneksi Internet.','Ok');
    }
  });

  //Google Analytics
  var gaPageTitle = "Home Page";
  ga_storage._trackPageview(gaPageTitle);

  //to hide splash screen on view load
  $scope.$on('$ionicView.loaded', function() {
    ionic.Platform.ready( function() {
      if(navigator && navigator.splashscreen){
        navigator.splashscreen.hide();
      }
    });
  });

  $scope.infoKesehatan = function(){
    $location.path('/app/articleCategory');
  }

  $scope.tipsP3K = function(){
    $location.path('/app/tipsP3K');
  }

  $scope.direktoriRS = function(){
    $location.path('/app/direktoriRSAll');
  }

  $scope.direktoriDoc = function(){
    $location.path('/app/direktoriDocList');
  }

  $scope.calculator = function(){
    $location.path('/app/calculator');
  }

  $scope.searchPage = function(){
    $location.path('/app/search');
  }

  var postId = '';
  $scope.articleList = [];

  $scope.loadMorePosts = function(){
    //set url
    var url = GlobalURL.get() + "/modules/posts/_ext_recent_listing.php";
    var data = {};
    if(postId != ''){
      var data = {post_id: postId};
    }
    BalancedHTTP.post(url,data).then(
        function(response){
          console.log(JSON.stringify(response));
          if(response.data.status == 1){
            //save the last id for infinite scroll
            //for 7 posts
            postId = response.data.data[6].id;
            var tempArr = $scope.articleList;
            $scope.articleList = [];
            if(tempArr.length > 0){
              $scope.articleList = tempArr.concat(response.data.data);
            }else{
              $scope.articleList = response.data.data;
            }
          }else{
            BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },
        function(response){
          BalancedAlert.alert('Sync Failed', response.data, 'Ok');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
  }

  $scope.share = function (id, title, name) {
      var subject = '';
      var message = 'DokterSehat.com - ' + title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      console.log(id);
      var link = 'http://doktersehat.com/' + name;
      console.log(link);

      window.plugins.socialsharing.share(message, subject, null, link);
  }

  $scope.readMore = function(catId, id){
    var path = '/app/articleCategory/' + catId + '/' + id
    $location.path(path);
  }

});
