angular.module('dokterSehat.controllers.informasiKesehatan', [])

.controller('articleCategoryController', function($scope) {
  //Google Analytics
  var gaPageTitle = "Article Category Listing Page";
  ga_storage._trackPageview(gaPageTitle);

  $scope.contentLoaded = false;

  $scope.articleCategory = [
    { title: 'Umum', id: 7, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/download67-5532_120x120.jpg' },
    { title: 'Penyakit & Kanker', id: 1709, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/download68-6180_120x120.jpg' },
    { title: 'Anak', id: 8, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/download45-7674_120x120.jpg' },
    { title: 'Kehamilan', id: 2, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/images66-5485_120x120.jpg' },
    { title: 'Alternatif & Herbal', id: 1718, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/download46-3713_120x120.jpg' },
    { title: 'Pengobatan', id: 5, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/Etravirinelarge-14762_120x120.jpg' },
    { title: 'Psikologi', id: 157, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/images74-5342_120x120.jpg' },
    { title: 'Seksualitas', id: 3, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/images26-5852_120x120.jpg' },
  ];

  $scope.contentLoaded = true;
})

.controller('articleListController', function($scope, $stateParams, GlobalURL, BalancedHTTP, BalancedAlert, $location) {
  $scope.contentLoaded = false;
  $scope.categoryId = $stateParams.categoryId;

  //Google Analytics
  var gaCategoryTitle = "";
  if($scope.categoryId == 7){
    gaCategoryTitle = "Umum";
  }else if($scope.categoryId == 1709){
    gaCategoryTitle = "Penyakit & Kanker";
  }else if($scope.categoryId == 8){
    gaCategoryTitle = "Anak";
  }else if($scope.categoryId == 2){
    gaCategoryTitle = "Kehamilan";
  }else if($scope.categoryId == 1718){
    gaCategoryTitle = "Alternatif & Herbal";
  }else if($scope.categoryId == 5){
    gaCategoryTitle = "Pengobatan";
  }else if($scope.categoryId == 157){
    gaCategoryTitle = "Psikologi";
  }else if($scope.categoryId == 3){
    gaCategoryTitle = "Seksualitas";
  }
  var gaPageTitle = "Article Listing Category: " + gaCategoryTitle;
  ga_storage._trackPageview(gaPageTitle);

  var postId = '';
  $scope.articleList = [];
  //set url
  var url = GlobalURL.get() + "/modules/posts/_ext_sync_listing.php";
  //set data
  var data = {category_id: $scope.categoryId};
  //get posts data
  BalancedHTTP.post(url,data).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.articleList = response.data.data;
          //save the last id for infinite scroll
          postId = response.data.data[4].id;
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });

  $scope.loadMorePosts = function(){
    var data = {category_id: $scope.categoryId, post_id: postId};

    console.log(JSON.stringify(data));

    BalancedHTTP.post(url,data).then(
        function(response){
          if(response.data.status == 1){
            //save the last id for infinite scroll
            postId = response.data.data[4].id;
            var tempArr = $scope.articleList;
            $scope.articleList = [];
            if(tempArr.length > 0){
              $scope.articleList = tempArr.concat(response.data.data);
            }else{
              $scope.articleList = response.data.data;
            }
          }else{
            BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },
        function(response){
          BalancedAlert.alert('Sync Failed', response.data, 'Ok');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
  }

  $scope.share = function (id, title, name) {
      var subject = '';
      var message = 'DokterSehat.com - ' + title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      console.log(id);
      var link = 'http://doktersehat.com/' + name;
      console.log(link);

      window.plugins.socialsharing.share(message, subject, null, link);
  }

  $scope.readMore = function(id){
    var path = '/app/articleCategory/' + $scope.categoryId + '/' + id
    $location.path(path);
  }

  // $scope.articleList = [
  //   { title: 'Ciri-Ciri Kualitas Air Yang Baik', id: 1, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/download67-5532_120x120.jpg', created_date: '24 May 2015', short_description: 'Kualitas air yang baik sangatlah diperlukan untuk kebutuhan hidup manusia, hewan dan tumbuhan. Oleh karena itu kita perlu mengetahui ciri-ciri kualitas air yang baik untuk dikonsumsi khususnya oleh...' },
  //   { title: 'Waspada Bahaya Air Mineral Dalam Kemasan Botol Palsu', id: 2, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/download66-9029_120x120.jpg', created_date: '24 May 2015', short_description: 'Masyarakat harus waspada. Sekarang ini beredar air mineral kemasan dalam botol banyak yang palsu. Botolnya asli, tapi isinya air isi ulang. Sangat bahaya buat kesehatan. Air kemasan dalam botol ini beredar...' },
  //   { title: 'Bahaya Air Mineral Mengandung Flouride', id: 3, picture: 'http://doktersehat.com/wp-content/uploads/et_temp/download65-9929_120x120.jpg', created_date: '24 May 2015', short_description: 'Setelah 22 tahun melakukan penelitian, akhirnya Harvard University menambah temuan betapa bahayanya Air Mineral yang mengandung Flourida yang saat ini juga terdapat dalam Air Mineral seperti Aqua kepunyaan Danone, tidak hanya Aqua saja Ron88 yang kini sahamnya dibeli Danone juga...' }
  // ];
})

.controller('articleController', function($scope, $location, $stateParams, GlobalURL, BalancedHTTP, BalancedAlert, $ionicModal, $ionicPopup, $anchorScroll, $ionicScrollDelegate) {

  //initial data
  $scope.title = '';
  $scope.picture = '';
  $scope.post_date = '';
  $scope.content = '';
  $scope.name = '';
  $scope.contentLoaded = false;

  var postId = $stateParams.articleId;
  //set url
  var url = GlobalURL.get() + "/modules/posts/_ext_get_details.php";
  //set data
  var data = {post_id: postId};
  //get posts data
  BalancedHTTP.post(url,data).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.title = response.data.data.title;
          $scope.picture = response.data.data.picture;
          $scope.post_date = response.data.data.post_date;
          $scope.content = response.data.data.content;
          $scope.name = response.data.data.name;
          //Google Analytics
          var gaPageTitle = "Article Details - " + $scope.title;
          ga_storage._trackPageview(gaPageTitle);
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });


  //get list of related articles
  url = GlobalURL.get() + "/modules/posts/_ext_related_listing.php";
  $scope.categoryId = $stateParams.categoryId
  //set data
  data = {category_id: $scope.categoryId, post_id: postId};
  //get posts data
  BalancedHTTP.post(url,data).then(
      function(response){
        if(response.data.status == 1){
          $scope.articleList = response.data.data;
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });

  $scope.share = function (type) {
      var subject = '';
      var message = 'DokterSehat.com - ' + $scope.title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      var link = 'http://doktersehat.com/' + $scope.name;

      if(type == 'facebook'){
        window.plugins.socialsharing.shareViaFacebook(message, null, link, function() {console.log(success)}, function(errormsg){console.log(errormsg)});
      }else if(type == 'twitter'){
        window.plugins.socialsharing.shareViaTwitter(message, null, link);
      }else if(type == 'whatsapp'){
        message = $scope.title + " Read more at DokterSehat: ";
        window.plugins.socialsharing.shareViaWhatsApp(message, null, link, function(){console.log(success)}, function(errormsg){console.log(errormsg)});
      }else if(type == 'email'){
        window.plugins.socialsharing.shareViaEmail(
          message + link, // can contain HTML tags, but support on Android is rather limited:  http://stackoverflow.com/questions/15136480/how-to-send-html-content-with-image-through-android-default-email-client
          $scope.title,
          null, // TO: must be null or an array
          null, // CC: must be null or an array
          null, // BCC: must be null or an array
          null, // FILES: can be null, a string, or an array
          null, // called when sharing worked, but also when the user cancelled sharing via email (I've found no way to detect the difference)
          null // called when error
        );
      }
  }
  //comments modal
  $ionicModal.fromTemplateUrl('./view/informasi_kesehatan/comments_modal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.close = function(){
    $scope.modal.hide();
  }
  //Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });

  $scope.showComment = function(){
    // v0.1 open inappbrowser - failed because of website ads
    // var commentUrl = 'http://doktersehat.com/' + $scope.name + '/#respond';
    // console.log(commentUrl);
    // window.open(commentUrl, '_blank', 'location=yes');
    //Google Analytics
    var gaPageTitle = "Article Show Comments - " + $scope.title;
    ga_storage._trackPageview(gaPageTitle);

    $scope.modal.show();
  }

  //get comments
  $scope.comments = [];
  url = GlobalURL.get() + "/modules/posts/_ext_get_comments.php";
  //set data
  data = {post_id: postId};
  //get posts data
  BalancedHTTP.post(url,data).then(
    function(response){
      if(response.data.status == 1){
        $scope.comments = response.data.data;
        if($scope.comments == null || $scope.comments.length <= 0){
          $scope.commentAvailable = false;
        }else{
          $scope.commentAvailable = true;
        }
      }else{
        console.log("no record");
        $scope.commentAvailable = false;
        // BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
      }
    },
    function(response){
      $scope.contentLoaded = true;
      BalancedAlert.alert('Sync Failed', response.data, 'Ok');
    });

  $scope.commentsinput = {};

  function postComments(name,email,website,comments){
    //Google Analytics
    var gaPageTitle = "Article Post Comments - " + $scope.title;
    ga_storage._trackPageview(gaPageTitle);

    //push new comments to the array
    var newComment = {"author":name,"thumbnail":null,"comment_date":"Just now","content":comments,"parent_id":0, "reply":[], "new":true};
    $scope.commentAvailable = true;
    $scope.comments.push(newComment);
    //return the background color to normal - to create highlight effect
    highlightComment();

    //send comments to server
    url = GlobalURL.get() + "/modules/posts/_ext_write_comments.php";
    //set data
    var agent = device.platform + " " + device.version + " - " + device.model;
    data = {post_id: postId, author: name, email: email, website: website, content: comments, device: agent};
    //get posts data
    BalancedHTTP.post(url,data).then(
      function(response){
      },
      function(response){
      });
  }

  function highlightComment(){
    //return the background color to normal - to create highlight effect
    setTimeout(function(){
      var commentLength = $scope.comments.length - 1;
      $scope.comments[commentLength].new = false;
      $scope.$apply();
    }, 500);
  }

  //popover for writing comment
  var template = '<label class="item item-input"><input type="text" ng-model="commentsinput.name" required placeholder="Name*"></label><label class="item item-input"><input type="email" ng-model="commentsinput.email" required placeholder="Email*"></label><label class="item item-input"><textarea ng-model="commentsinput.comments" placeholder="Comments*"></textarea></label>';

  $scope.writeComment = function(){
    //Google Analytics
    var gaPageTitle = "Article Write Comments - " + $scope.title;
    ga_storage._trackPageview(gaPageTitle);

    $ionicPopup.show({
      template: template,
      title: 'Write Comments',
      subTitle: 'Required fields are marked *',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>Submit</b>',
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.commentsinput.name || !$scope.commentsinput.email || !$scope.commentsinput.comments) {
              //don't allow the user to close unless he enters wifi password
              e.preventDefault();
            } else {
              postComments($scope.commentsinput.name, $scope.commentsinput.email, "", $scope.commentsinput.comments);
              //clean up the form
              $scope.commentsinput.name = "";
              $scope.commentsinput.email = "";
              // $scope.commentsinput.website = "";
              $scope.commentsinput.comments = "";

              //scroll to the top comment where the new comment is
              $location.hash("top-comment");
              var handle = $ionicScrollDelegate.$getByHandle('commentScroll');
              handle.anchorScroll();

              return true;
            }
          }
        }
      ]
    });
  }

  //used to diffrentiate the css class for new comment
  $scope.newCommentChecker = function(comment){
    if(comment.new != null && comment.new == true){
      return 'item item-avatar item-text-wrap new-comment';
    }
    return 'item item-avatar item-text-wrap';
  }

  function postReplyComments(name,email,website,comments,parentId,commentData){
    //push new reply comments to the array
    var newReply = {"author":name,"thumbnail":null,"comment_date":"Just now","content":comments,"parent_id":parentId,"new":true};
    commentData.reply.push(newReply)
    //return the background color to normal - to create highlight effect
    highlightReplyComment(commentData);

    //send comments to server
    url = GlobalURL.get() + "/modules/posts/_ext_reply_comments.php";
    //set data
    var agent = device.platform + " " + device.version + " - " + device.model;
    data = {post_id: postId, author: name, email: email, website: website, content: comments, device: agent, parent_id: parentId};
    //get posts data
    BalancedHTTP.post(url,data).then(
      function(response){
      },
      function(response){
      });
  }

  function highlightReplyComment(comment){
    //return the background color to normal - to create highlight effect
    setTimeout(function(){
      var replyLength = comment.reply.length - 1;
      comment.reply[replyLength].new = false;
      $scope.$apply();
    }, 500);
  }

  $scope.replytoAuthor = null;

  //popover for writing comment
  var templateReply = '<p>Reply-to: {{replytoAuthor}}</p><label class="item item-input"><input type="text" ng-model="commentsinput.name" required placeholder="Name*"></label><label class="item item-input"><input type="email" ng-model="commentsinput.email" required placeholder="Email*"></label><label class="item item-input"><textarea ng-model="commentsinput.comments" placeholder="Comments*"></textarea></label>';

  $scope.replyComment = function(id, author, comment){
    $scope.replytoAuthor = author;

    $ionicPopup.show({
      template: templateReply,
      title: 'Reply Comment',
      subTitle: 'Required fields are marked *',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
        {
          text: '<b>Submit</b>',
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.commentsinput.name || !$scope.commentsinput.email || !$scope.commentsinput.comments) {
              //don't allow the user to close unless he enters wifi password
              e.preventDefault();
            } else {
              postReplyComments($scope.commentsinput.name, $scope.commentsinput.email, "", $scope.commentsinput.comments,id, comment);
              //clean up the form
              $scope.commentsinput.name = "";
              $scope.commentsinput.email = "";
              // $scope.commentsinput.website = "";
              $scope.commentsinput.comments = "";
              return true;
            }
          }
        }
      ]
    });
  }

  //used to diffrentiate the css class for new comment
  $scope.newReplyCommentChecker = function(reply){
    if(reply.new != null && reply.new == true){
      return 'item item-avatar no-border item-text-wrap new-comment';
    }
    return 'item item-avatar no-border item-text-wrap';
  }

  $scope.readMore = function(categoryId, id){
    var path = '/app/articleCategory/' + categoryId + '/' + id
    $location.path(path);
  }
});
