angular.module('dokterSehat.controllers.calculator', [])

.controller('calculatorListingController', function($scope, $location, SelectedCalculator) {
    //Google Analytics
    var gaPageTitle = "Calculator Overview Page";
    ga_storage._trackPageview(gaPageTitle);

    $scope.listings = SelectedCalculator.getAll();

    $scope.selectCalculator = function(id){
      if(id == 1){
        $location.path('/app/calculatorBMI');
      }else if(id == 2){
        $location.path('/app/calculatorKalori');
      }else if(id == 4){
        $location.path('/app/calculatorUsiaHamil');
      }else if(id == 5){
        $location.path('/app/calculatorPrediksi');
      }
    }
})

.controller('calculatorBMIController', function($scope, $stateParams, $location, CalculatorProcess, $ionicModal) {
    //Google Analytics
    var gaPageTitle = "Calculator Page - BMI";
    ga_storage._trackPageview(gaPageTitle);

    $scope.data = {};

    //default value
    $scope.data.method = "i";

    $scope.reset = function(){
      $scope.data.berat = null;
      $scope.data.tinggi = null;
      $scope.data.method = "i";
    }

    $scope.kalkulasi = function(){
      var results = CalculatorProcess.processBMI($scope.data);
      if(results){
        var path = '/app/calculatorBMIResults';
        $location.path(path);
      }
    }

    //info modal
    $ionicModal.fromTemplateUrl('./view/kalkulator/bmi_modal.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.info = function(){
      $scope.modal.show();
    }
    $scope.close = function(){
      $scope.modal.hide();
    }
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
      $scope.modal.remove();
    });
})

.controller('calculatorBMIResultsController', function($scope, CalculatorProcess) {
    //Google Analytics
    var gaPageTitle = "Calculator Results - BMI";
    ga_storage._trackPageview(gaPageTitle);

    $scope.results = CalculatorProcess.getResults();

    $scope.showResult = false;
    setTimeout(function ()
    {
     $scope.$apply(function()
     {
       $scope.showResult = true;
     });
   }, 900);
})

.controller('calculatorKaloriController', function($scope, $location, CalculatorProcess, $ionicModal) {
    //Google Analytics
    var gaPageTitle = "Calculator Page - Kalori";
    ga_storage._trackPageview(gaPageTitle);

    $scope.data = {};

    //default value
    $scope.data.gender = "m";
    $scope.data.method = "m";

    $scope.reset = function(){
      $scope.data.gender = "m";
      $scope.data.method = "m";
      $scope.data.berat = null;
      $scope.data.tinggi = null;
      $scope.data.umur = null;
      $scope.data.level = null;
    }

    $scope.kalkulasi = function(){
      var results = CalculatorProcess.processKalori($scope.data);
      if(results){
        var path = '/app/calculatorKaloriResults';
        $location.path(path);
      }
    }

    //info modal
    $ionicModal.fromTemplateUrl('./view/kalkulator/kalori_modal.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.info = function(){
      $scope.modal.show();
    }
    $scope.close = function(){
      $scope.modal.hide();
    }
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
      $scope.modal.remove();
    });
})

.controller('calculatorKaloriResultsController', function($scope, CalculatorProcess) {
    //Google Analytics
    var gaPageTitle = "Calculator Results - Kalori";
    ga_storage._trackPageview(gaPageTitle);

    $scope.results = CalculatorProcess.getResults();
})

.controller('calculatorKesuburanController', function($scope, $location, CalculatorProcess, $ionicModal) {
    //Google Analytics
    var gaPageTitle = "Calculator Page - Kesuburan";
    ga_storage._trackPageview(gaPageTitle);

    $scope.data = {};

    //default value
    $scope.data.gender = "m";
    $scope.data.method = "m";

    $scope.reset = function(){
      $scope.data.gender = "m";
      $scope.data.method = "m";
      $scope.data.berat = null;
      $scope.data.tinggi = null;
      $scope.data.umur = null;
      $scope.data.level = null;
    }

    $scope.kalkulasi = function(){
      var results = CalculatorProcess.processKesuburan($scope.data);
      if(results){
        var path = '/app/calculatorKesuburanResults';
        $location.path(path);
      }
    }

    //info modal
    $ionicModal.fromTemplateUrl('./view/kalkulator/kesuburan_modal.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.info = function(){
      $scope.modal.show();
    }
    $scope.close = function(){
      $scope.modal.hide();
    }
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
      $scope.modal.remove();
    });
})

.controller('calculatorKesuburanResultsController', function($scope, CalculatorProcess) {
    //Google Analytics
    var gaPageTitle = "Calculator Results - Kesuburan";
    ga_storage._trackPageview(gaPageTitle);

    $scope.results = CalculatorProcess.getResults();
})

.controller('calculatorUsiaHamilController', function($scope, $location, CalculatorProcess, $ionicModal) {
    //Google Analytics
    var gaPageTitle = "Calculator Page - Usia Kehamilan";
    ga_storage._trackPageview(gaPageTitle);

    $scope.data = {};

    //default value

    $scope.reset = function(){
      $scope.data.date = null;
    }

    $scope.kalkulasi = function(){
      var results = CalculatorProcess.processUsiaHamil($scope.data);
      if(results){
        var path = '/app/calculatorUsiaHamilResults';
        $location.path(path);
      }
    }

    //info modal
    $ionicModal.fromTemplateUrl('./view/kalkulator/usia_hamil_modal.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.info = function(){
      $scope.modal.show();
    }
    $scope.close = function(){
      $scope.modal.hide();
    }
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
      $scope.modal.remove();
    });
})

.controller('calculatorUsiaHamilResultsController', function($scope, CalculatorProcess) {
    //Google Analytics
    var gaPageTitle = "Calculator Results - Usia Kehamilan";
    ga_storage._trackPageview(gaPageTitle);

    $scope.results = CalculatorProcess.getResults();

    if($scope.results.beratjanin > 1000){
      $scope.results.measurement = "kg";
      $scope.results.beratjanin = Math.round(($scope.results.beratjanin / 1000),2)
    }else{
      $scope.results.measurement = "gram";
    }

})

.controller('calculatorPrediksiController', function($scope, $location, BalancedAlert, CalculatorProcess, $ionicModal) {
    //Google Analytics
    var gaPageTitle = "Calculator Page - Prediksi Janin";
    ga_storage._trackPageview(gaPageTitle);

    $scope.data = {};

    //default value

    $scope.reset = function(){
      $scope.data.berat = null;
      $scope.data.week = null;
    }

    $scope.kalkulasi = function(){
      //checking
      if($scope.data.berat >= 30  && $scope.data.berat <= 99){
        if($scope.data.week >= 1  && $scope.data.week <= 44){
          var results = CalculatorProcess.processPrediksi($scope.data);
          if(results){
            var path = '/app/calculatorPrediksiResults';
            $location.path(path);
          }
        }else{
          BalancedAlert.alert('Invalid Input', "Your entered input is out of range.", 'Ok');
        }
      }else{
        BalancedAlert.alert('Invalid Input', "Your entered input is out of range.", 'Ok');
      }
    }

    //info modal
    $ionicModal.fromTemplateUrl('./view/kalkulator/prediksi_modal.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.info = function(){
      $scope.modal.show();
    }
    $scope.close = function(){
      $scope.modal.hide();
    }
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
      $scope.modal.remove();
    });
})

.controller('calculatorPrediksiResultsController', function($scope, CalculatorProcess) {
    //Google Analytics
    var gaPageTitle = "Calculator Results - Prediksi Janin";
    ga_storage._trackPageview(gaPageTitle);

    $scope.results = CalculatorProcess.getResults();

    if($scope.results.beratjanin > 1000){
      $scope.results.measurement = "kg";
      $scope.results.beratjanin = Math.round(($scope.results.beratjanin / 1000),2)
    }else{
      $scope.results.measurement = "gram";
    }

});
