angular.module('dokterSehat.service.calculator', [])

.service('SelectedCalculator', function() {
    var listings = [
      {"id": 1, "title": "Kalkulator BMI"},
      {"id": 2, "title": "Kalkulator Kalori"},
      // {"id": 3, "title": "Kalkulator Kesuburan"},
      {"id": 4, "title": "Kalkulator Usia Kehamilan"},
      {"id": 5, "title": "Prediksi Kesehatan Ibu & Janin"}
    ];

    this.getAll = function(){
      return listings;
    }

    this.getTitle = function(id){
      var title = null;
      angular.forEach(listings, function(value, key){
        if(parseInt(value.id) == parseInt(id)){
          title = value.title;
        }
      });
      return title;
    }
})

.service('CalculatorProcess', function() {
    var results = {};

    function kehamilan(week){
      var data = [["1","0.0","0","0.0"],
      ["2","0.0","0","0.0"],
      ["3","0.0","0","0.0"],
      ["4","0.0","0","0.0"],
      ["5","0.0","0","0.0"],
      ["6","0.0","0","0.0"],
      ["7","0.0","0","0.0"],
      ["8","0.0","0","0.0"],
      ["9","0.5","1","4.0"],
      ["10","0.7","2","4.0"],
      ["11","0.9","4","6.5"],
      ["12","1.1","7","6.5"],
      ["13","1.4","14","9.0"],
      ["14","1.7","25","9.0"],
      ["15","2.0","45","12.5"],
      ["16","2.3","70","12.5"],
      ["17","2.7","100","16.0"],
      ["18","3.0","140","16.0"],
      ["19","3.4","190","20.5"],
      ["20","3.8","240","20.5"],
      ["21","4.3","300","25.0"],
      ["22","4.7","360","25.0"],
      ["23","5.1","430","27.5"],
      ["24","5.5","501","27.5"],
      ["25","5.9","600","30.0"],
      ["26","6.4","700","30.0"],
      ["27","6.8","800","32.5"],
      ["28","7.2","900","32.5"],
      ["29","7.4","1001","35.0"],
      ["30","7.7","1175","35.0"],
      ["31","8.1","1350","37.5"],
      ["32","8.4","1501","37.5"],
      ["33","8.8","1675","40.0"],
      ["34","9.1","1825","40.0"],
      ["35","9.5","2001","42.5"],
      ["36","10.0","2160","42.5"],
      ["37","10.4","2340","45.0"],
      ["38","10.5","2501","45.0"],
      ["39","11.0","2775","47.5"],
      ["40","11.3","3001","47.5"],
      ["41","0.0","3250","50.0"],
      ["42","0.0","3501","50.0"],
      ["43","0.0","4001","52.5"],
      ["44","0.0","4501","52.5"]];

      var i = week - 1;
      
      return data[i];
    }

    function convertMonth(monthNumber){
      var month = new Array();
      month[0] = "Jan";
      month[1] = "Feb";
      month[2] = "Mar";
      month[3] = "Apr";
      month[4] = "May";
      month[5] = "Jun";
      month[6] = "Jul";
      month[7] = "Aug";
      month[8] = "Sep";
      month[9] = "Oct";
      month[10] = "Nov";
      month[11] = "Dec";

      return month[monthNumber];
    }

    this.processBMI = function(data){
      //BMI Calculation
      var bmi = data.berat/(data.tinggi * (data.tinggi/10000));
      //round to two decimal places
      results.bmi = Math.round(bmi * 100) / 100;
      //get results
      if(data.method == 's'){
        //singapore standard
        var lunderweight = 10; var hunderweight = 18.5;
        var lnormal = 18.51; var hnormal = 23;
        var loverweight = 23.1; var hoverweight = 27.4;
        var lobese = 27.5; var hobese =60;

        if ((lnormal<=bmi)&&(bmi<=hnormal)){
          results.result = "Tubuh ideal";
        }else if ((loverweight<=bmi)&&(bmi<=hoverweight)){
          results.result = "Tubuh gemuk";
        }else if ((lunderweight<=bmi)&&(bmi<=hunderweight)){
          results.result = "Tubuh kurus";
        }else if ((lobese<=bmi)&&(bmi<=hovese)){
          results.result = "Tubuh obesitas";
        }else{
          results.result = "Data tidak valid";
        }

      }else if(data.method == 'i'){
        //international standard
        var lunderw = 10; var hunderw = 16.9;
        var lunderweight = 17; var hunderweight = 18.5;
        var lnormal = 18.51; var hnormal = 25;
        var loverweight = 25.1; var hoverweight = 30;
        var lobese = 30.1; var hobese =33;
        var lveryobese = 33.1; var hveryobese = 60;

        if ((lnormal<=bmi)&&(bmi<=hnormal)){
          results.result = "Tubuh ideal";
        }else if ((loverweight<=bmi)&&(bmi<=hoverweight)){
          results.result = "Tubuh gemuk";
        }else if ((lunderw<=bmi)&&(bmi<=hunderw)){
          results.result = "Tubuh terlalu kurus";
        }else if ((lunderweight<=bmi)&&(bmi<=hunderweight)){
          results.result = "Tubuh kurus";
        }else if ((lobese<=bmi)&&(bmi<=hovese)){
          results.result = "Tubuh obesitas";
        }else if (bmi < 10 || bmi > 60){
          results.result = "Data tidak valid";
        }else{
          results.result = "Tubuh sangat obesitas";
        }
      }
      //finish processing
      return true;
    }

    this.processKalori = function(data){
      var age = data.umur;
      var sex = data.gender;
      var heightcm = data.tinggi;
      var weight1 = data.berat;
      var tdee = data.level;
      var formula = data.method;
      var bmr;

      //kg to pounds
      var weight = weight1;
      //height cm to inch
      var inch = heightcm;

      //formula Harris-Benedict Formula
      if (formula == "h"){
        if (sex == "m"){
          bmr =  66.5 + (13.75 * weight) + (5.003 * inch) - (6.775 * age);
        }else {
          bmr =  655.1 + (9.563 * weight) + (1.85 * inch) - (4.676 * age);
        }
      }else {
        //formula Mifflin - St Jeor Formula
        if (sex=="m"){
          bmr =  10 * weight + 6.25 * inch - 5 * age + 5;
        }else {
          bmr =  10 * weight + 6.25 * inch - 5 * age -161;
        }
      }

      var result = Math.round(bmr * 100) / 100;

      if (tdee == 1 ){
        result = bmr * 1.2;
      }else if (tdee == 2 ){
        result = bmr * 1.375;
      }else if (tdee == 3 ){
        result = bmr * 1.55;
      }else if (tdee == 4 ){
        result = bmr * 1.725;
      }else if (tdee == 5 ){
        result = bmr * 1.9;
      }
      //round to two decimals
      result = Math.round(bmr * 100) / 100;

      results.result = result;
      results.result1 = Math.round((result*80)/100);
      results.result2 = Math.round((result*60)/100);
      return true;
    }

    this.processUsiaHamil = function(data){

      var dd = data.date.getDate();
      var mm = data.date.getMonth();
      //plus one -> for php if else logic
      mm = mm + 1;
      var yyyy = data.date.getFullYear();
      var mml = 0;
      //count the difference in days
      var oneDay = 24*60*60*1000;
      var today = new Date();
      var days = Math.round(Math.abs((today.getTime() - data.date.getTime())/(oneDay)));
      var weeks = Math.ceil(days/7);

      var mm_arr = [4,6,9,11];

      if ((mm==1) || (mm==3)) {
      	if (dd < 25){
      		ddl = dd + 7;
      	} else {
      		ddl = 7- (31 - dd);
      		mm1 = mm+1;
      	}
      	mml = mml + mm + 9;
      	yyyyl = yyyy;
      }else if (mm==2) {
      	if (dd < 22){
      		ddl = dd + 7;
      	} else {
      		ddl = 7 - (28 - dd);
      		mm1 = mm+1;
      	}
      	mml = mml + mm + 9;
      	yyyyl = yyyy;
      }else if(mm_arr.indexOf(mm) > 0) {
      	if (dd < 24){
      		ddl = dd + 7;
      	} else {
      		ddl = 7 - (30 - dd);
      		mm1 = mm+1;
      	}
      	mml = mml + mm - 3;
      	yyyyl = yyyy + 1;
      }else {
        if (dd < 24){
      		ddl = dd + 7;
      	} else {
      		ddl = 7 - (30 - dd);
      		mm1 = mm+1;
      	}
      	mml = mml + mm - 3;
      	yyyyl = yyyy + 1;
      }

      //adjust back to javascript month after php if else
      mml = mml - 1;

      var dataKehamilan = kehamilan(weeks);
      console.log(dataKehamilan);

      results.days = days;
      results.weeks = weeks;
      results.date = ddl;
      results.month = convertMonth(mml);
      results.year = yyyyl;
      results.beratibu = dataKehamilan[1];
      results.beratjanin = dataKehamilan[2];
      results.tinggijanin = dataKehamilan[3];

      return true;
    }

    this.processPrediksi = function(data){

      var dataKehamilan = kehamilan(data.week);
      results.week = data.week;
      results.beratibu = dataKehamilan[1];
      results.totalberat = parseInt(data.berat) + parseInt(results.beratibu);
      results.beratjanin = dataKehamilan[2];
      results.tinggijanin = dataKehamilan[3];

      return true;
    }

    this.getResults = function(){
      return results;
    }

});
