angular.module('dokterSehat.controllers.search', [])

.controller('searchController', function($scope, $stateParams, $location, GlobalURL, BalancedHTTP, BalancedAlert) {
  //Google Analytics
  var gaPageTitle = "Search Page";
  ga_storage._trackPageview(gaPageTitle);

  $scope.input = {};
  var postId = '';
  var url = GlobalURL.get() + "/modules/search/_ext_search_info.php";

  $scope.search = function(){
    //set data
    var data = {search_query: $scope.input.query};
    //get posts data
    BalancedHTTP.post(url, data).then(
        function(response){
          if(response.data.status == 1){
            //Google Analytics
            var gaPageTitle = "Search - Query: " + $scope.input.query;
            ga_storage._trackPageview(gaPageTitle);

            $scope.data = response.data.data;
            var dataLength = response.data.data.length - 1;
            postId = response.data.data[dataLength].id;
          }else{
            // BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
            //need to do handling for no record
          }
        },
        function(response){
          // BalancedAlert.alert('Sync Failed', response.data, 'Ok');
          //need to do handling for no record
        });
  }

  $scope.loadMorePosts = function(){
    var data = {search_query: $scope.input.query, post_id: postId};

    BalancedHTTP.post(url,data).then(
        function(response){
          if(response.data.status == 1){
            //save the last id for infinite scroll
            var dataLength = response.data.data.length - 1;
            postId = response.data.data[dataLength].id;
            var tempArr = $scope.data;
            $scope.data = [];
            if(tempArr.length > 0){
              //Google Analytics
              var gaPageTitle = "Search Load More - Query: " + $scope.input.query;
              ga_storage._trackPageview(gaPageTitle);

              $scope.data = tempArr.concat(response.data.data);
            }else{
              $scope.data = response.data.data;
            }
          }else{
            // BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
            //need to do handling for no record
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },
        function(response){
          // BalancedAlert.alert('Sync Failed', response.data, 'Ok');
          //need to do handling for no record
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
  }

});
