angular.module('dokterSehat.controllers.tipsP3K', [])

.controller('tipsP3KController', function($scope, $stateParams, GlobalURL, BalancedHTTP, BalancedAlert) {
  //Google Analytics
  var gaPageTitle = "Tips P3K Overview Page";
  ga_storage._trackPageview(gaPageTitle);

  $scope.thumbnail;
  $scope.content;
  $scope.listings;
  $scope.contentLoaded = false;

  //set url
  var url = GlobalURL.get() + "/modules/tips_p3k/_ext_get_head.php";
  //set data
  var data = {category_id: $scope.categoryId};
  //get posts data
  BalancedHTTP.get(url).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.thumbnail = response.data.data.picture;
          $scope.content = response.data.data.content;
          $scope.listings = response.data.data.listings;
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });
})

.controller('tipsP3KDetailsController', function($scope, $sce, $stateParams, GlobalURL, BalancedHTTP, BalancedAlert) {
  //initial data
  $scope.title;
  $scope.content;
  $scope.contentLoaded = false;

  var id = $stateParams.id;
  //set url
  var url = GlobalURL.get() + "/modules/tips_p3k/_ext_get_details.php";
  //set data
  var data = {post_id: id};
  //get posts data
  BalancedHTTP.post(url,data).then(
      function(response){
        $scope.contentLoaded = true;
        if(response.data.status == 1){
          $scope.title = response.data.data.title;
          $scope.name = response.data.data.name;
          $scope.content = response.data.data.content;

          $scope.contentSafe = $sce.trustAsHtml($scope.content);

          //Google Analytics
          var gaPageTitle = "Tips P3K - " + $scope.title;
          ga_storage._trackPageview(gaPageTitle);
        }else{
          BalancedAlert.alert('Sync Failed', response.data.message, 'Ok');
        }
      },
      function(response){
        $scope.contentLoaded = true;
        BalancedAlert.alert('Sync Failed', response.data, 'Ok');
      });

  $scope.share = function (type) {
      var subject = '';
      var message = 'DokterSehat.com - ' + $scope.title;
      message = message.replace(/(<([^>]+)>)/ig,"");
      var link = 'http://doktersehat.com/' + $scope.name;

      if(type == 'facebook'){
        window.plugins.socialsharing.shareViaFacebook(message, null, link, function() {console.log(success)}, function(errormsg){console.log(errormsg)});
      }else if(type == 'twitter'){
        window.plugins.socialsharing.shareViaTwitter(message, null, link);
      }else if(type == 'whatsapp'){
        message = $scope.title + ". Read more at DokterSehat: "
        window.plugins.socialsharing.shareViaWhatsApp(message, null, link, function(){console.log(success)}, function(errormsg){console.log(errormsg)});
      }else if(type == 'email'){
        window.plugins.socialsharing.shareViaEmail(
          message + link, // can contain HTML tags, but support on Android is rather limited:  http://stackoverflow.com/questions/15136480/how-to-send-html-content-with-image-through-android-default-email-client
          $scope.title,
          null, // TO: must be null or an array
          null, // CC: must be null or an array
          null, // BCC: must be null or an array
          null, // FILES: can be null, a string, or an array
          null, // called when sharing worked, but also when the user cancelled sharing via email (I've found no way to detect the difference)
          null // called when error
        );
      }
  }
});
