balanced.service('BalancedLocation', function($q){
  //initiate result object
  var result = {
      latitude : '0',
      longitude : '0',
      accuracy : '0',
      altitude : '0',
      altitudeAccuracy : '0',
      heading : '0',
      speed : '0',
      timestamp : '0',
      error : ''
  };

  this.getCurrentLocation = function () {
      var def = $q.defer();
      var result;
      if (navigator.geolocation) {
          var options = { enableHighAccuracy: true };
          navigator.geolocation.getCurrentPosition(
            //on success function
            function(position){
              result.latitude = position.coords.latitude;
              result.longitude = position.coords.longitude;
              result.accuracy = position.coords.accuracy;
              result.altitude = position.coords.altitude;
              result.altitudeAccuracy = position.coords.altitudeAccuracy;
              result.heading = position.coords.heading;
              result.speed = position.coords.speed;
              result.timestamp = position.timestamp;
              def.resolve(result);
            },
            //on error function
            function(error){
              switch (error.code) {
                  case error.PERMISSION_DENIED:
                      result.error = "User does not allow the app to retrieve position information.";
                      def.resolve(result);
                      break;
                  case error.POSITION_UNAVAILABLE:
                      result.error = "The device is unable to retrieve a position. In general, this means the device is not connected to a network or can't get a satellite fix.";
                      def.resolve(result);
                      break;
                  case error.TIMEOUT:
                      result.error = "The request to get user location timed out.";
                      def.resolve(result);
                      break;
                  case error.UNKNOWN_ERROR:
                      result.error = "An unknown error occurred.";
                      def.resolve(result);
                      break;
              }
            }, options);
      }else {
          result.error = "GPS is not enabled.";
          def.resolve(result);
      }
      return def.promise;
  }
});
