balanced.service('BalancedPayPal', function(BalancedHTTP, CreditText){

  var value;
  var price;
  var currency;
  var itemName;
  //specific to EasySpa
  //can't be ignored for other project
  var emailAddress;

  this.initPaymentUI = function() {
    var clientIDs = {
      "PayPalEnvironmentProduction": "YOUR_PRODUCTION_CLIENT_ID",
      "PayPalEnvironmentSandbox": "AcyeZj2mhssOEuNTYMSl_V928ZcAQwyXhNrIHc7Y1kQVJpxnCtis7vvsIAk_TRd4ESy-zPX53ipmZX-t"
    };
    PayPalMobile.init(clientIDs, this.onPayPalMobileInit);
  };

  this.onPayPalMobileInit = function() {
    // must be called
    // use PayPalEnvironmentNoNetwork mode to get look and feel of the flow
    PayPalMobile.prepareToRender("PayPalEnvironmentSandbox", configuration(), onPrepareRender());
  };

  function configuration() {
    // for more options see `paypal-mobile-js-helper.js`
    var config = new PayPalConfiguration({
      merchantName: "EasySpa",
      merchantPrivacyPolicyURL: "http://www.easyspa.org/privacy-and-terms.html",
      merchantUserAgreementURL: "http://www.easyspa.org/privacy-and-terms.html"
    });
    return config;
  };

  function onPrepareRender() {

  };

  function onSuccesfulPayment(payment) {
    //update the server on successful transaction
    //specific to EasySpa
    //can't be ignored for other project
    var url = 'http://b-uat.com/easyspa/modules/spa_staff/_ext_add_credit.php';
    var data = {emailAddress: emailAddress,
                creditPurchased: value,
                purchaseCurrency: currency,
                purchaseAmount: price,
                purchaseTime: payment.response.create_time,
                transactionId: payment.response.id,
                platform: payment.client.platform};
    //get notifications
    BalancedHTTP.post(url, data).then(
    //on success
    function(response){
      var currentCredit = CreditText.get();
      var newCredit = parseInt(currentCredit) + parseInt(value);
      CreditText.set(newCredit);
    },
    //on error
    function(response){

    });
  };

  function onUserCanceled(result) {

  };

  function onAuthorizationCallback(authorization) {

  };

  function createPayment(priceData, currencyData, itemNameData, valueData) {
    // for simplicity use predefined amount
    var paymentDetails = new PayPalPaymentDetails(priceData, "0.00", "0.00");
    var payment = new PayPalPayment(priceData, currencyData, itemNameData, valueData, paymentDetails);
    return payment;
  };

  this.makePayment = function(priceData, currencyData, itemNameData, valueData, emailAddressData){
    price = priceData;
    currency = currencyData;
    itemName = itemNameData;
    value = valueData;
    //specific to EasySpa
    //can't be ignored for other project
    emailAddress = emailAddressData;

    PayPalMobile.renderSinglePaymentUI(createPayment(priceData, currencyData, itemNameData, valueData), onSuccesfulPayment, onUserCanceled);
  };

});
